%function [xpos, ypos] = getmouse(marker_str)
% function [xpos, ypos] = getmouse(marker_str)
% While the left mouse button is pressed down, record the x-y positions, until the button is released.
%
% marker_str (default '.') is the kind of marker used to plot each point

marker_str = '.';
%if nargin < 1, marker_str = '.'; end

xpos = []; ypos = [];
figure(1);
clf
axis([0 100 0 100])
hold on

% store points
cmd1 = [ ...
    'pos=get(gca,''currentpoint'');' ...
    'xpos = [xpos pos(1,1)]; ypos = [ypos pos(1,2)];' ...
    'plot(pos(1,1), pos(1,2), marker_str);' ...
%    'plot(pos(1,1), pos(1,2), ''.'');' ...
%    'set(gcf,''xdata'',pos(1,1),''ydata'',pos(1,2));' ...
       ];


% reset
cmd2 = [ ...
    'set(gcf,''windowbuttonmotionfcn'','''');' ...
    'set(gcf,''windowbuttonupfcn'','''');' ...
%    'set(gcf,''windowbuttonupfcn'',''return;'');' ...
       ];


cmd3 = [ ...
    'set(gcf,''windowbuttonmotionfcn'',cmd1);' ...
    'set(gcf,''windowbuttonupfcn'',cmd2);' ...
       ];

set(gca, 'buttondownfcn',cmd3); 

%hold off
