% PLOT_ELLIPSE
% h=plot_ellipse(x,y,theta,a,b,lineColor)
%
% This routine plots an ellipse with centre (x,y), axis lengths a,b
% with major axis at an angle of theta radians from the horizontal.
% lineColor has default value

%
% Author: P. Fieguth
%         Jan. 98
%
%http://ocho.uwaterloo.ca/~pfieguth/Teaching/372/plot_ellipse.m
%
% modified by Tomer Hertz - color option added.

function h=plot_ellipse(x,y,theta,a,b,lineColor)

if(nargin < 6)
  lineColor= 'b';
end

np = 100;
ang = [0:np]*2*pi/np;
pts = [x;y]*ones(size(ang)) + [cos(theta) -sin(theta); sin(theta) cos(theta)]*[cos(ang)*a; sin(ang)*b];
h=plot( pts(1,:), pts(2,:),lineColor );
