function mk_ps_from_clqs(dbn, T, cliques, dir)

% Draw multiple copies of the DBN,
% and indicate the nodes in each clique by shading the nodes.
% Generate a series of color postscript files.
% This was used to create the figures in chap 3 of my thesis.

cd(dir)
flip = 1;

% plot each clique to a figure, and save to a file
C = length(cliques);
for c=1:C
  figure(1);clf
  [dummyx, dummyy, h] = draw_dbn(dbn.intra, dbn.inter, flip, T, -1);
  for i=cliques{c}
    set(h(i,2), 'facecolor', 'r'); 
  end
  print(gcf, '-depsc', sprintf('clq%d.ps', c))
end
