function b = acyclic(adj_mat, directed)
% ACYCLIC Returns true iff the graph has no (directed) cycles.
% b = acyclic(adj_mat, directed)

if nargin < 2, directed = 1; end

if directed
  R = reachability_graph(adj_mat);
  b = ~any(diag(R)==1);
else
  [d, pre, post, height, cycle] = dfs(adj_mat,1,directed);
  b = ~cycle;    
end
