function marginal = marginal_family(engine, i, t, add_ev)
% MARGINAL_FAMILY Compute the marginal on the specified family (hmm)
% marginal = marginal_family(engine, i, t, add_ev)

if nargin < 3, t = 1; end
if nargin < 4, add_ev = 0; end

ss = engine.slice_size;

if t==1 | ~engine.persist_bitv(i)
  bigT = engine.one_slice_marginal(:,t);
  id = engine.marg_fam1_ndx_id(i);
  ps = engine.parents{i};
  dom = [ps i] + (t-1)*ss;
else % some parents are in previous slice
  id = engine.marg_fam2_ndx_id(i);
  bigT = engine.two_slice_marginal(:,t-1); % t-1 and t
  ps = engine.parents{i+ss};
  dom = [ps i+ss] + (t-2)*ss;
end
marginal.domain = dom;

%ndx = get_ndx(id, engine.ndx_type);
%marginal.T = marg_table_ndx(bigT, engine.maximize, ndx, engine.ndx_type);
global SD_NDX
ndx = SD_NDX{id};
marginal.T = marg_table_ndxSD(bigT, engine.maximize, ndx);
marginal.mu = [];
marginal.Sigma = [];

if add_ev
  marginal = add_ev_to_dmarginal(marginal, engine.evidence, engine.node_sizes);
end    

