function marginal = marginal_family(engine, i, t)
% MARGINAL_FAMILY Compute the marginal on the specified family (jtree_ndx_dbn)
% marginal = marginal_family(engine, i, t)

bnet = bnet_from_engine(engine);
ss = length(bnet.intra);

if t==1
  slice = 1;
  query = i;
  ps = bnet.parents{query};
  dom = [ps query] + (t-1)*ss;
elseif engine.persist_bitv(i) % myismember(i, engine.persist) % some parents are in previous slice
  slice = t-1;
  query = i+ss;
  ps = bnet.parents{query};
  dom = [ps query] + (t-2)*ss;
else % transient node - all parents in same slice
  slice = t;
  query = i;
  ps = bnet.parents{query};
  dom = [ps query] + (t-1)*ss;
end

if isempty(engine.T), error('must call enter_evidence before marginal_family'), end

if slice==engine.T
  J = engine.jtree_struct1;
else
  J = engine.jtree_struct;
end
c = J.clq_ass_to_node(query);
id = J.marg_fam_ndx_id(query);
ndx = get_ndx(id, engine.ndx_type);
marginal.domain = dom;
marginal.T = marg_table_ndx(engine.clpot{c,slice}, engine.maximize, ndx, engine.ndx_type);
