function b = back(engine, bfuture, f, t)

if f.t ~= t
  error('mixed up time stamps')
end
if t==1
  b = back1(engine, bfuture, f, t);
  return;
end

ndx_type = engine.ndx_type;
bnet = bnet_from_engine(engine);
ss = bnet.nnodes_per_slice;

int = engine.interface;
D = engine.in_clq;
C = engine.out_clq;

id = engine.marg_inclq_onto_int_ndx_id;
ndx = get_ndx(id, ndx_type);
phiD = marg_table_ndx(bfuture.clpot{D}, engine.maximize, ndx, ndx_type);

id = engine.marg_outclq_onto_int2_ndx_id;
ndx = get_ndx(id, ndx_type);
phiC = marg_table_ndx(f.clpot{C}, engine.maximize, ndx, ndx_type);

id = engine.mult_int_onto_int_ndx_id;
ndx = get_ndx(id, ndx_type);
ratio = divide_by_table_ndx(phiD, phiC, ndx, ndx_type);

id = engine.mult_int2_onto_outclq_ndx_id;
ndx = get_ndx(id, ndx_type);
f.clpot{C} = mult_by_table_ndx(f.clpot{C}, ratio, ndx, ndx_type);

[b.clpot, seppot] = distribute_evidence(engine.jtree_engine, f.clpot, f.seppot);
for c=1:length(b.clpot)
  [b.clpot{c}, lik] = normalise(b.clpot{c});
  ll(c) = log(lik + (lik==0)*eps);  
end
b.t = t;
