function marginal = marginal_nodes(engine, b, nodes, t, add_ev, is_fam)
% function marginal = marginal_nodes(engine, b, nodes, t, add_ev, is_fam) (jtree_2TBN)

if nargin < 6, is_fam = 0; end
ss = engine.slice_size;

if ~is_fam & (t > 1) & (nodes<=ss)
  nodes = nodes + ss;
end

node = nodes(end);

ndx_type = engine.ndx_type;

if t==1
  c = clq_containing_nodes(engine.jtree_engine1, nodes, is_fam);
  if is_fam
    id = engine.marg_fam1_ndx_id(node);
  else
    id = engine.marg_node1_ndx_id(node);
  end 
  ndx = get_ndx(id, ndx_type);
else
  c = clq_containing_nodes(engine.jtree_engine, nodes, is_fam);
  if is_fam
    id = engine.marg_fam_ndx_id(node);
  else
    id = engine.marg_node_ndx_id(node);
  end
  ndx = get_ndx(id, ndx_type);
end
if c == -1
  error(['no clique contains ' nodes])
end
bigpot = b.clpot{c};
marginal.T = marg_table_ndx(bigpot, engine.maximize, ndx, ndx_type);


% we convert the domain to the unrolled numbering system
% so that add_ev_to_dmarginal (maybe called in update_ess) extracts the right evidence.
if t > 1
   marginal.domain = nodes+(t-2)*ss;
else 
   marginal.domain = nodes;
end
assert(~add_ev);




