function marginal = marginal_nodes(engine, query)
% MARGINAL_NODES Compute the marginal on the specified query nodes (jtree)
% marginal = marginal_nodes(engine, query)
%
% 'query' must be a subset of some clique; an error will be raised if not.

if length(query)==1
  marginal.T = engine.node_marginals{query};
  marginal.domain = query;
else
  c = clq_containing_nodes(engine, query);
  if c < 0
    error(['no clique containing query ' query]);
  end
  marginal = pot_to_marginal(marginalize_pot(engine.clpot{c}, query, engine.maximize));  
end
