function [clpot, seppot] = distribute_evidence(engine, clpot, seppot)
% DISTRIBUTE_EVIDENCE Do message passing from root to leaves (parents then children)
% [clpot, seppot] = distribute_evidence(engine, clpot, seppot)

ndx_type = engine.ndx_type;
for n=engine.preorder
  for c=engine.preorder_children{n}
    mult_ndx = get_ndx(engine.mult_cl_by_sep_ndx_id(c,n), ndx_type);
    marg_ndx = get_ndx(engine.marg_cl_onto_sep_ndx_id(n,c), ndx_type);

    clpot{c} = divide_by_table_ndx(clpot{c}, seppot{n,c}, mult_ndx, ndx_type); 
    seppot{n,c} = marg_table_ndx(clpot{n}, engine.maximize, marg_ndx, ndx_type);
    clpot{c} = mult_by_table_ndx(clpot{c}, seppot{n,c}, mult_ndx, ndx_type);
  end
end
