
%translate our contraints from vector forms into a single matrix in which

% M(i,j)= 1 if Xi and Xj are positively constrained.
% M(i,j)=-1 if Xi and Xj are negatively constrained.
% M(i,j)= 0 if we have no constraint over Xi and Xj.

function [ PosInds, NegInds ]= createConstraintMatrix(chunklets,antiChunklets)

N= length(chunklets);

constraintsMat= eye(N);   


%update all positive constraints.
s= max(chunklets);
for i=1:s

  inds= find(chunklets == i);
  L=length(inds);
  inds2=[ reshape( repmat(inds,L,1),L^2,1), repmat(inds',L,1) ];
  constraintsMat(sub2ind([N,N],inds2(:,1),inds2(:,2)))=1;
  
%   tempVec= zeros(1,N);
%   tempVec(inds)=1;
%   tempMat= tempVec'*tempVec;
%   constraintsMat= constraintsMat + tempMat;
   
end

%remove diagonal 2's (caused by points that were constrained)
inds= find(constraintsMat == 2);
constraintsMat(inds)=1;

%negative constraints:
if(~isempty(antiChunklets))
  inds=sub2ind(size(constraintsMat),antiChunklets(:,1),antiChunklets(:,2));
  constraintsMat(inds)=-1;
  inds=sub2ind(size(constraintsMat),antiChunklets(:,2),antiChunklets(:,1));
  constraintsMat(inds)=-1;
end

PosInds=find(constraintsMat==1);
NegInds=find(constraintsMat==-1);


