% computes the centroid of each chunklet and substracts it from all
% chunklet members.
% ChunkletSizes is a vector containing the size of each chunklet in the data set.
% chunklets are assumed to be ordered.
% W is a weight vector which assigns current weight to each of the data points in the DataSet
%HANDLES situations where the chunklet is of size 1!!!

%returns:
% CenteredChunklets - centered chunklets after removing weighted average of each chunklet.
function [CenteredChunklets]= centerWeightedChunklets(DataSet,ChunkletSizes,W)


[rows cols]= size(DataSet);

numOfChunklets= length(ChunkletSizes);
i=1;
CenteredChunklets=[];


for k=1:numOfChunklets
  
  if(~ChunkletSizes(k)==0)
    
      chunkNorm= sum(W(i:i+ChunkletSizes(k)-1));

      weightedChunklet= DataSet(:,i:i+ChunkletSizes(k)-1).*( (W(i:i+ChunkletSizes(k)-1)'*ones(1,rows))');
      centroid= sum(weightedChunklet')./chunkNorm;
  
      CenteredChunklets(:,i:i+ChunkletSizes(k)-1)= DataSet(:,i:i+ChunkletSizes(k)-1)- ...
          (centroid'*ones(1,ChunkletSizes(k)));
      
  end
  
  i= i+ChunkletSizes(k);
end


