% measure a nearest neighbor classification function
% Neighbors is a matrix in which each column contains the neighbors of 
% the column index sorted by eculidian distance
% Labels - is a matrix in which each column contains all the labeled points that belong to the 
% class of the data point with the column index.
% Csize is a vector in which the i'th value is the size of the class in which the index i belongs to.

%NieghborErrors is a the indices of neighbors that are erred on for each image.
function  [ cum_purity , KNN ] = computeNeighbourStats3(Neighbours, ClassSizes, Ks)

[ k , n ]=size(Neighbours);

% prepare labels vector
a=cumsum(ClassSizes);
a=[ 0 a ];
for i=1:length(a)-1
    v(a(i)+1:a(i+1))=i;
end

% compute error mat
nei_classes=v(Neighbours);
true_nei_classes=ones(k,1)*v;

error_mat=nei_classes-true_nei_classes;

error_mat=~(~error_mat);

% compute statistics
cum_purity=ones(1,k)-mean(cumsum(error_mat)')./(1:k);
clear error_met;


if ~isempty(Ks)
  KNN= zeros(1,length(Ks));
  for j=1:length(Ks)
      if(Ks(j) > size(nei_classes,2))
	break
      end
      Rel_nei=nei_classes(1:Ks(j),:);
        for i=1:length(ClassSizes)
            votes(i,:)=sum(Rel_nei==i,1);
        end
        [stam , Wins ]=max(votes);
        KNN(j)=length(find(Wins==v))/n;
    end
else
    KNN=[];
end



