% this function evaluates the quality of a distance matrixs between data points according to nearest neighbour criteria. 

%params:

% distances  - an n*n disrances matrix between points

% ClassSizes - a vector with the size of each class. the data is assumed to be ordered with full label continuity

%returns:

%NeighborPurity - cell array of vectors of max number of neighbors
%which in the k'th index holds the purity of neighbors till the k'th
%neighobor.

function [ NeighborPurity,  KNN ]= evalDistances( distances,ClassSizes , Ks)

if ( ~exist('Ks','var') | isempty(Ks) )
    Ks=[];
    k=min(ClassSizes);
else
  if( max(Ks)> size(distances,1)-1 )
    k=size(distances,1)-1;
  else
    k= max(min(ClassSizes),max(Ks));
  end
end

%compute k-NN of all data points before and after transformation:
[Sval Sind] = sort(distances);
Neighbours= Sind(2:k+1,:);

%compute errors on all neighbors:

[ NeighborPurity ,  KNN ]= computeNeighbourStats3( Neighbours , ClassSizes,Ks);

