% this function comuptes several statistics about the global developing
% hypothesis. Given:
%       Hyp - the hypothesis as a n*n pairs matrixs of the global margins
%       PosInds - a list of indexes into Hyp with 'equal' constraints.
%       NegInds - a list of indexes into Hyp with 'not equal' constraints.
% returns
% SupervisionError- the error % over supervised constraints
% SupervisionMargin - the average margin over supervised constraints
% UnsupervisedMargin - the average margin over unsupevised constraints.
% Total Margin - the average margin over all datapoints.

function [ SupervisedError , SupervisedMargin , UnsupervisedMargin, TotalMargin ,...
        TotalExpMargin , SupervisedExpMargin ]=   ...
    evalGlobalMargin(Hyp,PosInds,NegInds);

n=length(Hyp);
tmpPos=Hyp(PosInds);
tmpNeg=Hyp(NegInds);

Hyp=abs(Hyp); 

Hyp(PosInds)=tmpPos;
Hyp(NegInds)=-tmpNeg;

% copute Mean unsupervised margin
UnsupervisedInds=setdiff(1:n^2,[PosInds ; NegInds]);
UnsupervisedMargin=mean(Hyp(UnsupervisedInds));

% SupervisedError is the error over constraints
SupervisedError=mean( 1- ( (sign(Hyp([PosInds ; NegInds]))+1)/2 ) );

% SupervisedMargin is the average margin over constraints
SupervisedMargin=mean(Hyp([PosInds ; NegInds]));

%with diagonals for now
TotalMargin= mean(Hyp(:));

TotalExpMargin=sum(exp(-Hyp(:)));

SupervisedExpMargin=sum(exp(-Hyp([PosInds ; NegInds ])));

