
%params:

% data   - data point matrix each data point is a row.
% M      - the number of classes.
% k      - the number of maximal correct neighbors.
% labels - a vector of length N (number of data points) with the label of each point.
% classSizes - a vector with the size of each of the classes.
% chunklets - chunklet vector noam stylle of length N.
% finalHyp - an hypothesis created by the boosting mechanism, unsigned map_margin matrix.
% initialHyp - the initial hyposthesis after the first boosting round as one baseline comparison.

% returns the matrix Purities containing the following commulative purities :
%   line 1 : eauclid metric
%   line 2 : whitened metric
%   line 3 : RCA commulative purity
%   line 4 : first boosting hypothesis
%   line 5 : last boosting hypothesis

function [ purities,  KNN ]= evaluateHyp2(data,labels, chunklets, finalHyp, Ks,visual_flag ) 

dim=size(data,2);

% sort the data according to labels continuity
[ stam ,Inds]=sort(labels);
data=data(Inds,:);
finalHyp{1}=finalHyp{1}(Inds,:);
finalHyp{1}=finalHyp{1}(:,Inds);
finalHyp{end}=finalHyp{end}(Inds,:);
finalHyp{end}=finalHyp{end}(:,Inds);

% measure class labels
plg=pilug(labels);
ClassSizes=plg(:,2)';

[ purities(1,:) KNN(1,:) ] = evalMahalanobis(data,ClassSizes,eye(dim),Ks);
[ purities(2,:) , KNN(2,:) ] = evalMahalanobis(data,ClassSizes,inv(cov(data)),Ks);
A=RCA(data,chunklets,1); %when using 1 will smooth RCA matrix.
[ purities(3,:) , KNN(3,:) ] = evalMahalanobis(data,ClassSizes,A,Ks);
[ purities(4,:), KNN(4,:) ] = evalDistances( finalHyp{1},ClassSizes,Ks );
[ purities(5,:), KNN(5,:) ] = evalDistances( finalHyp{end},ClassSizes ,Ks);

 if exist('visual_flag','var') & visual_flag==1
     figure;
     hold on;
     colors='rgbck';
     for i=1:5
         plot(purities(i,:),colors(i));
     end
     legend('euclid','whitened','rca','initial hyp','final hyp');
 end
 
 
 