function [bestParam] =bestParams(data,M,chunklets...
    ,EMParams,priorFlag,c_inds,nc_inds,singles)

% this function finds start conditions for the mixture parameters.
% if chunklets are given , they are used in the process.
% if weigths are given, they are used .

global pruned_flag; % used to indicate edge reduction. it should be known here 
% since we call calc_p_and_pll4 many times, and each tome demand that the pruning 
% will be done again. hence each time the flag should be set to 0 again.

number_of_starts=EMParams.number_of_starts;
noiseParam=EMParams.noiseParam;

if(~exist('priorFlag','var')) 
    priorFlag=0;
    % wishart prior option :	% this is a prior on the covmat assessed by RCA. the prior
    % is used if the flag is on.
    % according to 'priors on dag models' of Heckerman and Geiger, p. 10
end

if(~isfield(EMParams,'diag_covmat_flag'))
    diag_covmat_flag=0;
end

% M -the number of models
[ n , dim ]=size(data);

% check which weights are used :
if isfield(EMParams,'CW')
    W=zeros(n,1);
    [ W UnsupervisedInds ]=buildPointsWeights(EMParams,length(data));   % build weight vector
elseif isfield(EMParams,'w')
    W=EMParams.w'/sum(EMParams.w);
    EMParams.CW=[];
else
    %W=ones(n,1)/n; seems like bug to me - should sum to n
    W= ones(n,1);
    EMParams.CW=[];
end


% if needed , do RCA for the covmat
if EMParams.single_cov_mat_flag & ~isempty(chunklets)
    bestParam{1,2} = inv(weightedRCA(data,chunklets,W'));
    % to be replaced with weighted RCA
    
    if isfield(EMParams,'diag_covmat_flag') & (EMParams.diag_covmat_flag)
        bestParam{1,2}= bestParam{1,2}.*T;
    end
    EMParams.param{1,2}=bestParam{1,2};
end


% find centers
bll=-inf;       % best log liklihood.
i=1;
infFlag= 1;

while (i <= number_of_starts) 
    param = select_start_params4( data,M,EMParams,...
        noiseParam(ceil(i/(number_of_starts/3))),chunklets,W,priorFlag );
    if ~isempty(EMParams.CW)
        [ Ustam, Sstam, ll ,stamAss ] =calc_p_and_pll5(data,param,EMParams,UnsupervisedInds);
    else
        pruned_flag=0;
        [ stam , ll ]=calc_p_and_pll4(data,param,EMParams.single_cov_mat_flag...
            ,c_inds,nc_inds,singles,[],[],EMParams.w);
    end
    if ll>=bll
        bll=ll;
        bestParam=param;
    end
    i= i+1;
    if(bll ~= -inf)
        infFlag=0;
    end
end
if infFlag==1
    bestParam=[];
end

