%modified to handle small/large probabilities by using LogProbs.

% calculate map assignment of points using the given GMM model given
% by param. new version that also outputs highest  probability value.

function [ probabilities, mapAssignment]= calc_map_labeling1(data,param,M,singleCovMatFlag)

[rows cols]= size(data);
n= rows;
d= cols;

%in order to cope with models that have been removed.
M= (size(param,1));

for j=1:M
   if (singleCovMatFlag == 1)
      cov_index=1;
   else
      cov_index=j;
   end
   
   tempData=data-ones(n,1)*param{j,1}; % subtract the mean
   q1=tempData*inv(param{cov_index,2}).*tempData;
   expContent=-0.5*sum(q1,2);         % the exponent content

   LogProbs(:,j)= -(d/2)*log(2*pi) -0.5*log(det(param{cov_index,2}))+expContent;
   LogProbs(:,j)=LogProbs(:,j)+log(param{j,3});

end

m=max(LogProbs');
LogProbs=LogProbs- m'*ones(1,M);
probabilities=exp(LogProbs);

[  maxProb mapAssignment ]=max(probabilities');

