function [ nets ,singles ,nc_inds ,c_inds ,oth , SinglesW, PairsW ,HiddenW]= ...
    organize_constraints_info2(chunks, anti_chunks ,k , EMParams );
% create the mapping from observables to hiddens ( not trivial beacuse of the chunklets)
% and the graph of the net (not trivial because of the anti chunkletts )

% nets - subgraph and inference engine for each connected component
% singles - the indexes (in hidden numbering ) of single hidden nodes.
% nc_inds - indexes (in data numbering ) of non chunkletized points
% c_inds - cell array containing chunkletized points indexes (in data numbering )
% oth - observable to hidden map - place i contain hidden index of observable i.
% the observable to hidden table : first the chunkletts, then regular points.

% statistics computed to use in Partition Function calculation :

% SinglesW - In the case of weight type 0 : a vector with the weights of the 
% single hiddens which are different then 1. used when WeightsModel is 0.
% when this weight model is used, actually every hidden is weighted and the 
% weights are real. hiddens of chunklets are aggregates of the chunklets
% weights.
% PairsW - In the case of weight type 0 : the weights of both sides of
% pairs. a matrix 2*(number of pairs). this approximation currently doesn't
% work.
% HiddensW - the weights of all hidden nodes.

w=EMParams.w;
if isempty(w)
    w=ones(size(chunks));
end
global aa_flag;
global reduce_arcs;
global anti_chunk_num;

HiddenW=[];

plg=pilug(chunks');
nc_inds=find(chunks==-1);	% indexes of non chunklet points
if(~isempty(nc_inds))
  
  nh=plg(1,2)+size(plg,1)-1;	% number of hiddens
  c_inds=[];
  for i=2:size(plg,1)			
    c_inds{i-1}=find(chunks==plg(i,1));  % indexes of chunklet points
    HiddenW(i-1)=sum(w(c_inds{i-1}));    % weights of chunklet hiddens
  end

else
  nh= size(plg,1); %case of fully labeled data.
  c_inds=[];
  for i=1:size(plg,1)			
    c_inds{i}=find(chunks==plg(i,1));  % indexes of chunklet points
    HiddenW(i)=sum(w(c_inds{i}));    % weights of chunklet hiddens
  end
end


oth=chunks;		% observable to hidden map (needed to build the big graph )
if(~isempty(nc_inds))
  oth(nc_inds)=size(plg,1) : nh ;

  % the weights of hiddens for non chunkleted indexes
  HiddenW( size(plg,1) : nh )=w(nc_inds);
end


% anti-chunklets organization :

if isempty(anti_chunks)
    singles=1:nh;
    nets=[];
    PairsW=[];
else
    
    % the big graph :
    
    net=zeros(nh,nh);
    inds1=sub2ind([nh nh],oth(anti_chunks(:,1)),oth(anti_chunks(:,2)));
    net(inds1)=1;
    inds2=sub2ind([nh nh],oth(anti_chunks(:,2)),oth(anti_chunks(:,1)));
    net(inds2)=1;
    
    % because of the index reduction caused by going to hiddens the number of anti 
    % chunklets is decreased, and since it is used in aa-pf it is updated here.
    anti_chunk_num=length(union(inds1,inds2))/2;
    
    % turn graph into a group of connected networks 
    
    [ ccs singles ]=connected_components(net);
    nets=cell(length(ccs),1);
    for i=1:length(ccs)
        nets{i}.h_vars = ccs{i};
        if reduce_arcs==0		% no prunning will be done, so the nets are built now
            nets{i}.engine = inf_engine_from_mnet(net(ccs{i},ccs{i}),k );
        else	% don't build Jtree : it will be done after prunning in calc_p_and_pll
            nets{i}.engine.mnet=net(ccs{i},ccs{i});
        end
    end
    
    % prepare SingleW ( weights different then 1 ) and PairW (divides the weight of a hidden between the
    % anti-constraints sharing it). this is used in the approximation to the
    % partition function.
    
    if aa_flag  % if PF includes anti
        HiddenIndexes=[ oth(anti_chunks(:,1)), oth(anti_chunks(:,2)) ];
        plg=pilug(HiddenIndexes);
        tmpHash=zeros(1,nh);
        tmpHash(plg(:,1))=plg(:,2);
        PairsW = HiddenW( [ oth(anti_chunks(:,1)) ; oth(anti_chunks(:,2)) ] ) ./ ...
            tmpHash( [ oth(anti_chunks(:,1)) ; oth(anti_chunks(:,2)) ] );
    else
        PairsW=[];
    end
end

% limit HiddenW to (single) hiddens with chunklets ( pseudo or real ) 
if aa_flag
    SinglesW=HiddenW(singles);  % limit to singles
else
    SinglesW=HiddenW;   % don't limit to singles ( PF without anti )
end
SinglesW=SinglesW(SinglesW~=1); % limit to chunklets




