%add DistBoost paths to matlab paths. 

BOOST_HOME = pwd;

eval(sprintf('addpath ''%s''', BOOST_HOME));

files = {'General','Boosting','WeakLearner/em','WeakLearner/mnet_jtree','WeakLearner/Mstep', ...
         'WeakLearner/partition_function','WeakLearner/spanning_tree'};

for i=1:length(files)
  f = files{i};
  eval(sprintf('addpath ''%s''/%s', BOOST_HOME, f));
end



%unlight this for setting BNT path into matlab (Required to run DistBoost). If you have BNT
%installed, point to your current BNT directory in BNT_HOME.

%Adds BNT (Bayesian Network Toolbox) into matlab path: make sure to set the BNT_HOME variable to
%the correct BNT home path.

global BNT_HOME
BNT_HOME =  [BOOST_HOME,'/BNT'];

files = {'CPDs', 'general', 'misc', 'graph', 'graph/C', 'Graphics', 'stats1', 'stats2', ...
	 'netlab2', 'HMM', 'Kalman', 'Entropic', 'Entropic/Brand', ...
	 'inference', 'inference/static', 'inference/dynamic', 'inference/online', ...
	 'learning', 'potentials', 'potentials/Tables', ...
	 'examples/dynamic', 'examples/dynamic/HHMM', 'examples/dynamic/HHMM/Square', ...
	 'examples/dynamic/HHMM/Motif', 'examples/dynamic/SLAM', 'examples/limids', ...
	 'examples/static', 'examples/static/Misc',  'examples/static/Models', ...
	 'examples/static/Belprop', ...
	 'examples/static/Zoubin', 'examples/static/HME', 'examples/static/SCG', ...
	 'examples/static/dtree', ...
	 'examples/static/StructLearn', 'examples/static/fgraph'};

 
%eval(sprintf('addpath %s', BNT_HOME));
eval(sprintf('addpath ''%s'' ', BNT_HOME));
% to cope with filenames with spaces, we must use quotes

for i=1:length(files)
  f = files{i};
  %eval(sprintf('addpath %s/%s', BNT_HOME, f));
  eval(sprintf('addpath ''%s''/%s', BNT_HOME, f));
end


% Indices are used to speedup the multiplication/ marginalization of tables.
% They are used by potentials/Tables/mult_by_table_ndx, etc.
% The indices are stored in global variables, so they can be shared
% by different (instances of) inference engines.
% The indices are referenced using a unique identifier, which is
% generated by a global object called NDX_UID_GEN.
global B_NDX SD_NDX D_NDX
B_NDX = {};
SD_NDX = {};
D_NDX = {};
global B_UID_GEN SD_UID_GEN D_UID_GEN

% can only call uid constructor after path has been extended
SD_UID_GEN = uid_generator;
B_UID_GEN = uid_generator;
D_UID_GEN = uid_generator;